package checkers.quals;

import java.lang.annotation.Target;

/**
 * A special annotation intended solely for representing unqualified type in
 * the qualifier hierarchy, as an argument to {@link SubtypeOf#value()},
 * in the type qualifiers declarations.
 *
 * It cannot be used to annotate anything directly.
 */
@TypeQualifier
@SubtypeOf({})
@Target({}) // empty target prevents anno from annotating elements directly
public @interface Unqualified { }
