import checkers.interning.quals.*;

import java.util.*;

public class Arrays {

  public static Integer[] arrayclone_simple(Integer[] a_old) {
    int len = a_old.length;
    Integer[] a_new = new Integer[len];
    for (int i = 0; i < len; i++) {
      a_new[i] = new Integer(a_old[i]); // valid
    }
    return a_new;
  }

  public static void test(@Interned Integer i, @Interned String s) {
    @Interned String[] iarray1 = new @Interned String[2];
    @Interned String[] iarray2 = new @Interned String[] {"foo", "bar"};
    s = iarray1[1];             // error

    String[] sa = new String[22];
    iarray1 = sa;               // error
    sa = iarray1;               // OK

    String[@Interned] istrings1 = new String[@Interned 2];
    String[@Interned] istrings2 = new String[@Interned] {"foo", "bar"};
    s = istrings1[1];           // OK

    String[@Interned][@Interned] multi1 = new String[@Interned 2][@Interned 3];
    String[@Interned][@Interned] multi2 = new String[@Interned 2][@Interned];
  }

  public final /*@Interned*/ class InternedClass { }

  private static InternedClass[] returnToArray() {
    List<InternedClass> li = new ArrayList<InternedClass>();
    return li.toArray(new InternedClass[li.size()]);
  }

  private static void sortIt() {
    java.util.Arrays.sort(new InternedClass[22]);
  }

  private String[/*@Interned*/] elts_String;
  public /*@Interned*/ String min_elt() {
    return elts_String[0];
  }

  private double[][/*@Interned*/] elts_da;
  public void add_mod_elem (double[/*@Interned*/] v, int count) {
    elts_da[0] = v;
  }

  // // This test seems to require polymorphism over nonnull.
  // public static Object[] subarray(Object[] a, int startindex, int length) {
  //   Object[] result = new Object[length];
  //   System.arraycopy(a, startindex, result, 0, length);
  //   return result;
  // }
  // public void trim(int len) {
  //   /*@Interned*/ Object[/*@Interned*/] vals;
  //   Object[/*@Interned*/] new_vals = subarray(vals, 0, len);
  // }

}
